this.name               = "GWunits.js";
this.author             = "Ramirez";
this.copyright          = "October 2011";
this.description        = "Ship script for GW units, incorporating elements from Hired Guns";
this.version            = "3.0";



//this.shipCollided = function(player)

//{	log('collision detected')
	//++this.collisionCount
	//log(this.collisionCount)
	//if(this.collisionCount == 2)
	  // {this.ship.commsMessage("OK, I'll pull over!")
	   //this.ship.setAI("nullAI.plist")}
		//					  }



this.shipSpawned = function()
{	//this.collisionCount = 0
	this.missileCount = 10
	if(this.ship.primaryRole.indexOf("unit1") != -1)
    this.energyRatio = missionVariables.GW_unit1_rank_no/4
	if(this.ship.primaryRole.indexOf("unit2") != -1)
    this.energyRatio = missionVariables.GW_unit2_rank_no/4
	if(this.ship.primaryRole.indexOf("unit3") != -1)
    this.energyRatio = missionVariables.GW_unit3_rank_no/4
	if(this.ship.primaryRole.indexOf("unit4") != -1)
    this.energyRatio = missionVariables.GW_unit4_rank_no/4
	}

this.shipBeingAttacked = function()
{	//this.effectiveEnergy = this.ship.maxEnergy * this.energyRatio
	//if(this.ship.energy > this.effectiveEnergy)
	//this.ship.energy = this.effectiveEnergy

	this.effectiveEnergy = this.ship.maxEnergy * (1/3 + this.energyRatio*2/3)
	if(this.ship.energy > this.effectiveEnergy)
	this.ship.energy = this.effectiveEnergy
}
    
this.shipDied = function()
{   if(this.ship.primaryRole.indexOf("unit1") != -1)
    missionVariables.GW_unit1_status = "Inactive"
    if(this.ship.primaryRole.indexOf("unit2") != -1)
    missionVariables.GW_unit2_status = "Inactive"
    if(this.ship.primaryRole.indexOf("unit3") != -1)
    missionVariables.GW_unit3_status = "Inactive"
    if(this.ship.primaryRole.indexOf("unit4") != -1)
    missionVariables.GW_unit4_status = "Inactive"
    player.consoleMessage(this.ship.displayName+" destroyed.", 10)
    ++missionVariables.GW_mission_losses
    missionVariables.GW_mission_points -= 50
    worldScripts.GWunitstatus.updateUnitStatus()}
    
this.shipTargetDestroyed = function()
{	this.ship.commsMessage(expandDescription("[GW_target_destroyed]"))
    if(this.ship.primaryRole.indexOf("unit1") != -1)
    ++missionVariables.GW_unit1_kills
    if(this.ship.primaryRole.indexOf("unit2") != -1)
    ++missionVariables.GW_unit2_kills
    if(this.ship.primaryRole.indexOf("unit3") != -1)
    ++missionVariables.GW_unit3_kills
    if(this.ship.primaryRole.indexOf("unit4") != -1)
    ++missionVariables.GW_unit4_kills}

this.shipFiredMissile = function()
{	if(this.ship.name.indexOf("Gecko") != -1)
	{	--this.missileCount
		if(this.missileCount > 0)
		   {this.ship.awardEquipment("EQ_HARDENED_MISSILE")}
		   else
		   {this.ship.commsMessage("Out of missiles!")}
	}
		
}

this.locatePlayer = function()
	{
	this.playerArray = system.shipsWithPrimaryRole("player");
	if(this.playerArray.length > 0)
		{
		this.ship.target = this.playerArray[0];
		this.ship.reactToAIMessage("PLAYER_FOUND");
		}
	}
	
	this.checkPlayerDistance = function()
	{
	if(!player.ship)
		return;	
	else	
	{
	this.playerDistance = this.ship.position.distanceTo(player.ship.position);
	if(this.playerDistance > 51200) // if the escort is more than 2 scanner ranges from the player, move it just off-scanner
		{
		let playerDirection = player.ship.position.subtract(this.ship.position).direction(); 
		let newPosition = player.ship.position.subtract(playerDirection.multiply(20000));
		if (oolite.compareVersion('1.73') <= 0) 
			{
			this.ship.position = newPosition;
			}
		else 
			{
			this.ship.setPosition(newPosition);
			}
		this.ship.reactToAIMessage("PLAYER_MID");
		return;
		}

	if(this.playerDistance < 25600)
		{
		this.ship.reactToAIMessage("PLAYER_NEAR");
		}
	else
		{
		if(this.playerDistance > 38400 || player.ship.speed > 2000)
			{
			this.ship.reactToAIMessage("PLAYER_FAR");
			}
		else
			{
			this.ship.reactToAIMessage("PLAYER_MID");
			}
		}
	}}

this.combatCheck = function()
	{
	if(this.ship.target && this.ship.target.isDerelict)
		{
		this.ship.target = null;
		this.ship.reactToAIMessage("TARGET_EJECTED");
		}
		
	this.playerDistance = this.ship.position.distanceTo(player.ship.position);
	if(this.playerDistance > 51200) // if the escort is more than 2 scanner ranges from the player, break off combat
		{
		this.ship.AIState = "LOCATE_PLAYER";
		}
	else
		{
		this.ship.reactToAIMessage("ENEMY_FIRE");
		}
	}

this.findPlayerHostiles = function()
	{
	function isHostileToPlayer(entity) 
		{ 
		return (entity.isThargoid || (entity.isShip && entity.target && entity.target == player.ship && entity.hasHostileTarget && !entity.isDerelict));
		}
	
		{
		var targets = system.filteredEntities(this, isHostileToPlayer, this.ship, this.ship.scannerRange);
		if(targets.length > 0)
			{
			this.ship.target = targets[0];
                        this.ship.reactToAIMessage("HOSTILE_FOUND");
			}
		else
			{
			this.ship.reactToAIMessage("NO_HOSTILE_FOUND");
			}
		}
	}

this.fireCheck = function()
	{
	if(player.ship.target == this.ship && this.ship.target.isPlayer)
		{
		this.ship.reactToAIMessage("FRIENDLY_FIRE");
		}
	else
		{
		this.ship.reactToAIMessage("ENEMY_FIRE");
		}
	}



